﻿Imports System.Data.SqlClient
Imports Infragistics.Web.UI.ListControls

Partial Public Class AppointmentData
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Sub Load_Agency_Picklists()

        Dim AgencyName As String = ""
        Dim AgencyLocation As String = ""
        Dim AgencyKey As Int16
        Dim ThisSQLConnection As New SqlConnection
        Dim ThisSQLCommand As New SqlCommand

        If String.IsNullOrEmpty(CType(Me.FormView1.FindControl("HiddenField_AgencyKey"), HiddenField).Value) = False Then

            AgencyKey = CType(Me.FormView1.FindControl("HiddenField_AgencyKey"), HiddenField).Value

            ThisSQLConnection.ConnectionString = ConfigurationManager.ConnectionStrings("HeartlandCubeConnectionString").ConnectionString

            ThisSQLCommand.Connection = ThisSQLConnection
            ThisSQLCommand.CommandType = CommandType.Text
            ThisSQLCommand.CommandText = "Select AgencyName from dbo.Agency where pk=@pk"
            ThisSQLCommand.Parameters.AddWithValue("@pk", AgencyKey.ToString)

            ThisSQLCommand.Connection.Open()

            Try
                AgencyName = ThisSQLCommand.ExecuteScalar

            Catch ex As Exception
                'damn!
            End Try

            ThisSQLCommand.Connection.Close()

            If Me.FormView1.CurrentMode = FormViewMode.Edit Then

                Dim AgencyDropDown As DropDownList = CType(Me.FormView1.FindControl("DropDownList_AgencyName"), DropDownList)
                Dim LocationDropdown As DropDownList = CType(Me.FormView1.FindControl("DropDownList_AgencyLocation"), DropDownList)

                If AgencyName IsNot Nothing Then

                    AgencyDropDown.SelectedItem.Selected = False

                    AgencyDropDown.Items.FindByValue(AgencyName).Selected = True
                    CType(Me.FormView1.FindControl("SqlDataSource_AgencyLocation"), SqlDataSource).Select(DataSourceSelectArguments.Empty)
                End If

                LocationDropdown.SelectedItem.Selected = False
                LocationDropdown.SelectedValue = AgencyKey

            Else

                If AgencyName IsNot Nothing Then
                    CType(Me.FormView1.FindControl("lblAgencyName"), Label).Text = AgencyName.ToString
                End If

                ThisSQLCommand.Connection.Open()
                ThisSQLCommand.CommandText = "Select Location from dbo.Agency where pk=@pk"
                ThisSQLCommand.Parameters.Clear()
                ThisSQLCommand.Parameters.AddWithValue("@pk", AgencyKey.ToString)

                Try
                    AgencyLocation = ThisSQLCommand.ExecuteScalar

                Catch ex As Exception

                End Try

                ThisSQLCommand.Connection.Close()

                If AgencyLocation IsNot Nothing Then
                    CType(Me.FormView1.FindControl("lblAgencyLocation"), Label).Text = AgencyLocation.ToString
                End If


            End If

        End If

    End Sub

    Private Sub GetControl(ByVal prt As Control)
        'make checkboxes readonly
        For Each c As Control In prt.Controls

            If c.GetType().ToString = "System.Web.UI.WebControls.CheckBox" Then
                Dim tb As CheckBox = c
                tb.Attributes.Add("onclick", "return false;")
            End If

            If c.Controls.Count > 0 Then
                GetControl(c)
            End If

        Next

    End Sub

    Protected Sub DropDownList_AgencyName_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        CType(Me.FormView1.FindControl("DropDownList_AgencyLocation"), DropDownList).SelectedIndex = 0

    End Sub

    Protected Sub FormView1_ItemUpdating(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.FormViewUpdateEventArgs) Handles FormView1.ItemUpdating
        e.NewValues.Item("AgencyKey") = CType(Me.FormView1.FindControl("DropDownList_AgencyLocation"), DropDownList).SelectedValue
        e.NewValues.Item("Modified_By") = Session("UserName").ToString
        e.NewValues.Item("Modified_Date") = DateTime.Now.ToShortDateString
        e.NewValues.Item("AsOf") = e.NewValues.Item("Modified_Date")
        e.NewValues.Item("AssessmentDetailsKey") = Session("AssessmentDetailsKey").ToString
        e.NewValues.Item("AgencyKey") = CType(Me.FormView1.FindControl("DropDownList_AgencyLocation"), DropDownList).SelectedValue


        Dim ThisWebDropDown As WebDropDown = CType(Me.FormView1.FindControl("WebDropDown1"), WebDropDown)

    End Sub

    Protected Sub btnCalculate_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim GrossIncomeTextbox As TextBox = CType(Me.FormView1.FindControl("GrossIncomeTextBox"), TextBox)
        Dim AnnualIncomeTextBox As TextBox = CType(Me.FormView1.FindControl("AnnualIncomeTextBox"), TextBox)
        Dim IncomeLast3MonthsTextBox As TextBox = CType(Me.FormView1.FindControl("IncomeLast3MonthsTextBox"), TextBox)
        Dim MedicaidNumberTextBox As TextBox = CType(Me.FormView1.FindControl("MedicaidNumberTextBox"), TextBox)
        Dim FPGPTextBox As TextBox = CType(Me.FormView1.FindControl("FPGPTextBox"), TextBox)
        Dim FeeTextBox As TextBox = CType(Me.FormView1.FindControl("FeeTextBox"), TextBox)
        Dim NumberInHouseholdTextBox As TextBox = CType(Me.FormView1.FindControl("NumberInHouseholdTextBox"), TextBox)

        Dim DropDownList_IncomePeriod As DropDownList = CType(Me.FormView1.FindControl("DropDownList_IncomePeriod"), DropDownList)

        If (String.IsNullOrEmpty(GrossIncomeTextbox.Text.ToString) = False) And (String.IsNullOrEmpty(DropDownList_IncomePeriod.SelectedValue.ToString) = False) Then
            Select Case DropDownList_IncomePeriod.SelectedValue.ToString.ToUpper
                Case "DAILY"
                    IncomeLast3MonthsTextBox.Text = (CInt(GrossIncomeTextbox.Text) * 60).ToString
                    AnnualIncomeTextBox.Text = (CInt(GrossIncomeTextbox.Text) * 240).ToString
                Case "WEEKLY"
                    IncomeLast3MonthsTextBox.Text = (CInt(GrossIncomeTextbox.Text) * 12).ToString
                    AnnualIncomeTextBox.Text = (CInt(GrossIncomeTextbox.Text) * 50).ToString
                Case "BI-WEEKLY"
                    IncomeLast3MonthsTextBox.Text = (CInt(GrossIncomeTextbox.Text) * 6).ToString
                    AnnualIncomeTextBox.Text = (CInt(GrossIncomeTextbox.Text) * 25).ToString
                Case "MONTHLY"
                    IncomeLast3MonthsTextBox.Text = (CInt(GrossIncomeTextbox.Text) * 3).ToString
                    AnnualIncomeTextBox.Text = (CInt(GrossIncomeTextbox.Text) * 12).ToString
                Case "3 MONTHS"
                    IncomeLast3MonthsTextBox.Text = GrossIncomeTextbox.Text
                    AnnualIncomeTextBox.Text = (CInt(GrossIncomeTextbox.Text) * 4).ToString
            End Select
        Else
            IncomeLast3MonthsTextBox.Text = ""
            AnnualIncomeTextBox.Text = ""
        End If

        ' now fpgp
        If (String.IsNullOrEmpty(MedicaidNumberTextBox.Text) = True) And (String.IsNullOrEmpty(NumberInHouseholdTextBox.Text) = False) And (String.IsNullOrEmpty(AnnualIncomeTextBox.Text) = False) Then

            Dim FPGPpct As Double

            Dim ThisSQLConnection As New SqlConnection
            Dim ThisSQLCommand As New SqlCommand

            ThisSQLConnection.ConnectionString = ConfigurationManager.ConnectionStrings("HeartlandCubeConnectionString").ConnectionString

            ThisSQLCommand.Connection = ThisSQLConnection
            ThisSQLCommand.CommandType = CommandType.Text
            ThisSQLCommand.CommandText = "Select dbo.fpg(@NumInHouseHold,@Income)"
            ThisSQLCommand.Parameters.AddWithValue("@NumInHouseHold", CInt(NumberInHouseholdTextBox.Text))
            ThisSQLCommand.Parameters.AddWithValue("@Income", CInt(AnnualIncomeTextBox.Text))

            ThisSQLCommand.Connection.Open()

            Try
                FPGPpct = ThisSQLCommand.ExecuteScalar()
            Catch ex As Exception
                'damn!
            End Try

            ThisSQLCommand.Connection.Close()

            If FPGPpct > 0 Then

                FPGPTextBox.Text = FPGPpct.ToString

                If FPGPpct > 200 Then
                    FeeTextBox.Text = "150"
                Else
                    FeeTextBox.Text = 0
                End If

            End If

        End If

    End Sub

    Protected Sub FormView1_DataBound(ByVal sender As Object, ByVal e As EventArgs) Handles FormView1.DataBound

        If Me.FormView1.CurrentMode = FormViewMode.Edit Then

            CType(Me.FormView1.FindControl("DropDownList_AgencyLocation"), DropDownList).SelectedValue = CType(Me.FormView1.FindControl("HiddenField_AgencyKey"), HiddenField).Value

        Else

            'make checkboxes readonly
            GetControl(Me.FormView1)

        End If

        Me.PopulateSystemTypes()

        Me.Load_Agency_Picklists()


    End Sub

    Protected Sub PopulateSystemTypes()

        'get systemtypes records and populate webdropdown
        Dim ThisSQLConnection As New SqlConnection
        Dim ThisSQLCommand As New SqlCommand
        Dim ThisSQLReader As SqlDataReader = Nothing
        Dim ThisWebDropDown As WebDropDown = CType(Me.FormView1.FindControl("WebDropDown1"), WebDropDown)

        ThisSQLConnection.ConnectionString = ConfigurationManager.ConnectionStrings("HeartlandCubeConnectionString").ConnectionString

        ThisSQLCommand.Connection = ThisSQLConnection

        ThisSQLCommand.CommandType = CommandType.StoredProcedure

        ThisSQLCommand.CommandText = "dbo.USP_Select_System_Types_for_Client"

        ThisSQLCommand.Parameters.AddWithValue("@pk", Session("pk").ToString)

        ThisSQLCommand.Connection.Open()

        Try
            ThisSQLReader = ThisSQLCommand.ExecuteReader()

        Catch ex As Exception

            'crap!

        End Try

        While ThisSQLReader.Read()
            ' add to webdropdown
            For Each ThisItem As DropDownItem In ThisWebDropDown.Items
                If ThisSQLReader("SystemType").ToString = ThisItem.Value.ToString Then
                    ThisItem.Selected = True
                    Exit For
                End If
            Next
        End While

        ThisSQLReader.Close()

        ThisSQLCommand.Connection.Close()

    End Sub

    Protected Sub SaveSystemTypes()
        Dim ThisSQLConnection As New SqlConnection
        Dim ThisSQLCommand As New SqlCommand
        Dim ThisSQLReader As SqlDataReader = Nothing
        Dim FoundIt As Boolean = False

        Dim ThisWebDropDown As WebDropDown = CType(Me.FormView1.FindControl("WebDropDown1"), WebDropDown)

        ThisSQLConnection.ConnectionString = ConfigurationManager.ConnectionStrings("HeartlandCubeConnectionString").ConnectionString

        ThisSQLCommand.Connection = ThisSQLConnection
        ThisSQLCommand.CommandType = CommandType.StoredProcedure

        'first delete any existing system types in database that are not in the dropdown

        ThisSQLCommand.CommandText = "dbo.USP_Select_System_Types_for_Client"
        ThisSQLCommand.Parameters.AddWithValue("pk", Session("pk").ToString)

        ThisSQLCommand.Connection.Open()

        Try
            ThisSQLReader = ThisSQLCommand.ExecuteReader

        Catch ex As Exception

        End Try

        While ThisSQLReader.Read

            'check against the dropdownlist
            For Each ThisItem As DropDownItem In ThisWebDropDown.Items
                If ThisItem.Selected = True Then
                    FoundIt = False
                    If ThisSQLReader("SystemType").ToString = ThisItem.Value.ToString Then
                        FoundIt = True
                        Exit For
                    End If
                End If
            Next

            If FoundIt = False Then
                ' kill the record in the database
                ThisSQLCommand.Parameters.Clear()
                ThisSQLCommand.CommandType = CommandType.Text
                ThisSQLCommand.CommandText = "delete from dbo.SystemTypes where PersonKey=@pk and SystemType=@SystemType"
                ThisSQLCommand.Parameters.AddWithValue("@pk", Session("pk").ToString)
                ThisSQLCommand.Parameters.AddWithValue("@SystemType", ThisSQLReader("SystemType").ToString)
                Try
                    ThisSQLCommand.ExecuteNonQuery()

                Catch ex As Exception
                    'damn
                End Try

            End If

        End While

        ThisSQLReader.Close()

        'then add any systemtypes that are in the dropdown and not in the database
        ThisSQLCommand.CommandType = CommandType.StoredProcedure

        ThisSQLCommand.CommandText = "dbo.USP_Update_System_Types_for_Client"

        For Each ThisItem As DropDownItem In ThisWebDropDown.Items

            If ThisItem.Selected = True Then

                ThisSQLCommand.Parameters.Clear()
                ThisSQLCommand.Parameters.AddWithValue("@pk", Session("pk").ToString)
                ThisSQLCommand.Parameters.AddWithValue("@SystemType", ThisItem.Value.ToString)
                ThisSQLCommand.Parameters.AddWithValue("@Created_By", Session("UserName").ToString)
                Try
                    ThisSQLCommand.ExecuteNonQuery()

                Catch ex As Exception
                    'damn!
                End Try

            End If

        Next

        ThisSQLCommand.Connection.Close()

    End Sub

    Protected Sub SqlDataSource_AssessmentData_Updated(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceStatusEventArgs) Handles SqlDataSource_AssessmentData.Updated

        Me.SaveSystemTypes()

    End Sub

    Protected Sub SqlDataSource_AssessmentData_Updating(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceCommandEventArgs) Handles SqlDataSource_AssessmentData.Updating
        If Page.IsValid Then
            Me.SaveSystemTypes()
        End If
    End Sub
End Class