﻿Imports System.Data.SqlClient

Partial Public Class HeartlandCube
    Inherits System.Web.UI.MasterPage

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ClientInfostring As String = ""

        If Session("pk") IsNot Nothing Then
            ClientInfostring = "Current Client ID:" + Session("pk").ToString + "  "
        End If

        If Session("LastName") IsNot Nothing Then

            If Session("LastName").ToString.Length > 0 Then
                ClientInfostring = ClientInfostring + Session("LastName").ToString + ",  "
            End If

        End If

        If Session("FirstName") IsNot Nothing Then

            If Session("FirstName").ToString.Length > 0 Then
                ClientInfostring = ClientInfostring + Session("FirstName").ToString + ",  "
            End If

        End If

        If Session("DOB") IsNot Nothing Then

            If Session("DOB").ToString.Length > 0 Then
                ClientInfostring = ClientInfostring + Session("DOB").ToString + ",  "
            End If

        End If

        If Session("MHUID") IsNot Nothing Then

            If Session("MHUID").ToString.Length > 0 Then
                ClientInfostring = ClientInfostring + Session("MHUID").ToString + ",  "
            End If

        End If

        Me.lblClientInfo.Text = ClientInfostring

    End Sub

    Protected Sub UltraWebMenu1_MenuItemClicked(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebNavigator.WebMenuItemEventArgs) Handles UltraWebMenu1.MenuItemClicked
        If (Session("pk") IsNot Nothing) And (e.Item.Text = "New Appointment") Then
            ' create new appoint, then redirect to appointmentdetails
            Dim ThisSQLConnection As New SqlConnection

            ThisSQLConnection.ConnectionString = ConfigurationManager.ConnectionStrings("HeartlandCubeConnectionString").ConnectionString

            Dim ThisSQLCommand As New SqlCommand

            ThisSQLCommand.Connection = ThisSQLConnection

            ThisSQLCommand.CommandType = CommandType.StoredProcedure

            ThisSQLCommand.CommandText = "USP_Create_New_Assessment"

            ThisSQLCommand.Parameters.AddWithValue("PersonKey", CInt(Session("pk").ToString))
            ThisSQLCommand.Parameters.AddWithValue("Created_By", Session("UserName").ToString)

            Dim AssessmentDetails_pk As New SqlParameter("@AssessmentDetails_pk", SqlDbType.Int)
            AssessmentDetails_pk.Direction = ParameterDirection.Output
            ThisSQLCommand.Parameters.Add(AssessmentDetails_pk)

            ThisSQLCommand.Connection.Open()

            Try
                ThisSQLCommand.ExecuteNonQuery()

            Catch ex As Exception
                Dim errormessage As String = ex.Message

            End Try

            ThisSQLCommand.Connection.Close()

            Session("AssessmentDetailsKey") = AssessmentDetails_pk.Value
            Response.Redirect("~/Heartland/AppointmentData.aspx")


        End If
        If Session("pk") IsNot Nothing And (e.Item.Text = "View/Edit Appointment") Then
            Dim AssessmentDetailsKey As Int32 = 0

            Dim ThisSQLConnection As New SqlConnection

            ThisSQLConnection.ConnectionString = ConfigurationManager.ConnectionStrings("HeartlandCubeConnectionString").ConnectionString

            Dim ThisSQLCommand As New SqlCommand

            ThisSQLCommand.Connection = ThisSQLConnection

            ThisSQLCommand.CommandType = CommandType.Text

            ThisSQLCommand.CommandText = "select max(pk) from dbo.AssessmentDetails where PersonKey = @PersonKey"

            ThisSQLCommand.Parameters.AddWithValue("PersonKey", Session("pk").ToString)

            ThisSQLCommand.Connection.Open()

            Try
                AssessmentDetailsKey = ThisSQLCommand.ExecuteScalar
            Catch ex As Exception
                'crap!
            End Try

            ThisSQLCommand.Connection.Close()

            If AssessmentDetailsKey > 0 Then
                Session("AssessmentDetailsKey") = AssessmentDetailsKey
                Response.Redirect("~/Heartland/AppointmentData.aspx")
            End If

        End If
    End Sub
End Class